<%@ Page Language="C#" AutoEventWireup="true" CodeFile="AmazonAndFlickr.aspx.cs" Inherits="AmazonAndFlickr" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Amazon Book Search and Flickr Photo Search on One Page</title>
     <atlas:ScriptManager ID="scriptManager" runat="server" >
            <Services>
                <atlas:ServiceReference Path="~/AmazonPox.asbx" /> 
                <atlas:ServiceReference Path="~/Flickr.asbx" /> 
            </Services> 
    </atlas:ScriptManager>    
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <br />
        Please enter your search criteria:
        <br />
        <input type="text" id="txtSearchText" style="width: 191px" />
        <br />
        <button id="btnSearch" onclick="return OnSearch();" style="width: 196px">Search</button> 
        <br />
        <br />
        <div id="results"></div>  
        <br />
        <div id="imagesFlickr"></div> 
    </div>
   
    <script type="text/javascript" language="JavaScript">   
        var txtSearchText = document.getElementById('txtSearchText');
        var nextAmazonPage = 1;
        var nextFlickrPage = 1;
        
        function OnSearch()
        { 
            var parameters = { 'Keywords' : txtSearchText.value };
             
            if (nextAmazonPage > 1)
                parameters.Page = nextAmazonPage;     
		    Samples.AmazonPox.Search(parameters,
		        {
                    onMethodComplete:OnCompleteAmazonSearch,
                    onMethodTimeout:OnTimeout,
                    onMethodError:OnError,
                    userContext: "Amazon Search via Get"
                }       
            );
           
            if (nextFlickrPage > 1)
                parameters.Page = nextFlickrPage;   
		    Samples.Flickr.Search(parameters,
		        {
                    onMethodComplete:OnCompleteFlickrSearch,
                    onMethodTimeout:OnTimeout,
                    onMethodError:OnError,
                    userContext: "Flickr Search via Get"
                }       
            );
                        
        }
        
        function OnCompleteFlickrSearch(result) 
        {            
            if (result)
            {
                if ( (result[0].TotalPages > 1) && (nextFlickrPage < result[0].TotalPages) )
                {
                    nextFlickrPage++;
                    document.getElementById('btnSearch').innerHTML = "Next Page";
                 } 
                        
                var strHTML = "<table>";
                var startNewRow = true; 
                for (var i =0; i<result.length; i++) 
                {
                    if (startNewRow)
                    {
                        strHTML += "<tr>";
                    }
                    //Should be able to do this serverside.
                    strHTML += "<td>" + "<img src='http://static.flickr.com/" + result[i]['Server'] + "/"
                                                        + result[i]['Id'] + "_" + result[i]['Secret'] + ".jpg?v=0' /></td>"
                    if(!startNewRow)
                    {
                        strHTML += "</tr>";
                    }
                    
                    startNewRow = !startNewRow;  
                }
               strHTML += "</table>" 
               //alert(strHTML); 
               var outputElem = document.getElementById('imagesFlickr');    
               outputElem.innerHTML = strHTML;            
            }
        }

        function OnCompleteAmazonSearch(result) 
        {
            //logic to turn on paging
            if (result != null)
            {
                if ( (result[0].TotalPages > 1) && (nextAmazonPage < result[0].TotalPages) )
                {
                    nextAmazonPage++;
                    document.getElementById('btnSearch').innerHTML = "Next Page";
                 } 
                         
                var resultText = "<table border='1' cellspacing='1' cellpadding='1' style='border-right: black thin solid; border-top: black thin solid; border-left: black thin solid; border-bottom: black thin solid'>";
                resultText += "<tr><td align='center'><b>Title</b></td><td align='center'><b>Author</b></td><td align='center'><b>Url</b></td></tr>";
                
                for (i=0; i < result.length ; i++)
                {
                    resultText += "<tr><td>" + result[i].Title + "</td><td>" + result[i].Author + "</td><td><a target='new_window' href='" + result[i].BookLink + "'>Click to view Amazon details</a></td></tr>";      
                }  
               
                resultText += "</table>"; 
                document.getElementById('results').innerHTML = resultText; 
           } 
        }
        
        function OnTimeout(request, userContext) 
        {
            var timeoutString = "The call to '" + userContext + "' failed due to time out!"; 
            alert(timeoutString);
        }
   
        function OnError(result, response, userContext) 
        {
            var errorString = "Test '" + userContext + "' failed!";
            if (result == null) {
                errorString += "  Status code='" + response.get_statusCode() + "'";
            }
            else {
                errorString += 
                     "  Message='" + result.get_message() +
                    "'\r\nstackTrace = " + result.get_stackTrace();
            }
            
            alert(errorString);
        }
        
    </script>    
    
    </form>
</body>
</html>
